define class COMBase as session
	ErrorMessage  = ''			&& The error message
	ErrorOccurred = .F.			&& .T. if an error occurred
	Name          = 'COMBase'

	dimension ErrorMessage_COMAttrib[4]
	ErrorMessage_COMAttrib[1] = 0x100000	&& read-only
	ErrorMessage_COMAttrib[2] = 'Contains details about errors'
	ErrorMessage_COMAttrib[3] = 'ErrorMessage'
	ErrorMessage_COMAttrib[4] = 'String'

	dimension ErrorOccurred_COMAttrib[4]
	ErrorOccurred_COMAttrib[1] = 0x100000	&& read-only
	ErrorOccurred_COMAttrib[2] = 'Contains True if an error occurred'
	ErrorOccurred_COMAttrib[3] = 'ErrorOccurred'
	ErrorOccurred_COMAttrib[4] = 'String'

* Set up the environment the way we want.

	procedure Init
		set ansi       off
		set bell       off
		set compatible off
		set cpdialog   off
		set deleted    on
		set exact      off
		set exclusive  off
		set fullpath   on
		set multilocks on
		set near       off
		set notify     off
		set nulldisplay to ''
		set safety     off
		set talk       off
		set unique     off

* Set CENTURY after SYSFORMATS, since SYSFORMATS changes CENTURY.

		set sysformats on
		set century    on
	endproc

* Release ourselves.

	procedure Release
		release This
	endproc

* Get information about the error and set ErrorOccurred and ErrorMessage.

	procedure Error(tnError, tcMethod, tnLine)
		local laError[1], ;
			lnRows
		with This
			aerror(laError)
			.ErrorOccurred = .T.
			.ErrorMessage  = laError[iif(tnError = 1429, 3, 2)]
		endwith
	endproc

* Reset the error properties.

	procedure ResetError
		with This
			.ErrorMessage  = ''
			.ErrorOccurred = .F.
		endwith
	endproc
enddefine
